
package jp.gr.java_conf.koto.notavacc;

import java.util.*;
import java.io.*;
import jp.gr.java_conf.koto.util.*;
import jp.gr.java_conf.koto.notavacc.parser.*;

public class Environment {
    public final Properties parameters;
    
    public final Logger logger;
    
    public final String sourceDir;
    public final String destinationDir;
    public final String target;
    public final boolean parentSupport;
    public final boolean separateOutput;
    public final boolean dryRun;
    public final boolean experimental;
    public final boolean debug;
    public final boolean withoutParentPath;
    public final String manualLocale;
    public final boolean outputForManual;
    
    public final String sourceEncoding;
    public final String destinationEncoding;
    
    public File processingFile;
    public Environment(Logger logger, CommandLineChecker commandLine, String sourceEncoding, String destinationEncoding) {
        this.parameters = new Properties();
        InputStream parametersStream = new BufferedInputStream(Environment.class.getResourceAsStream("parameters.properties"));
        try {
            parameters.load(parametersStream);
            parametersStream.close();
        } catch (IOException x) {
            throw new RuntimeException(x);
        }
        
        this.logger = logger;
        this.sourceEncoding = sourceEncoding;
        this.destinationEncoding = destinationEncoding;
        
        sourceDir = commandLine.argumentOf("source-path");
        destinationDir = commandLine.argumentOf("destination-path");
        target = commandLine.argumentOf("target");
        parentSupport = commandLine.countOf("x-parent-support") > 0;
        separateOutput = commandLine.countOf("x-separate-output") > 0;
        dryRun = commandLine.countOf("dry-run") > 0;
        experimental = commandLine.countOf("experimental") > 0;
        debug = commandLine.countOf("debug") > 0;
        withoutParentPath = commandLine.countOf("x-without-parent-path") > 0;
        manualLocale = commandLine.argumentOf("javadoc-lang");
        outputForManual = commandLine.countOf("x-output-for-manual") > 0;
    }
}

