
package jp.gr.java_conf.koto.notavacc.lrg;

import java.util.*;

public final class StringTerminal extends Terminal {
    public StringTerminal(String name) {
        super(name);
    }
    
    public String toString() {
        //return '"' + getName() + '"';
        
        StringBuffer result = new StringBuffer();
        
        String name = getName();
        for (int i = 0; i < name.length(); i++) {
            char ch = name.charAt(i);
            switch (ch) {
            default:
                if (0x0020 <= ch && ch <= 0x007E) {
                    result.append(ch);
                } else {
                    result.append("\\u").append(toHexCode(ch));
                }
                break;
            case '\n':   result.append("\\n");      break;
            case '\t':   result.append("\\t");      break;
            case '\b':   result.append("\\b");      break;
            case '\r':   result.append("\\r");      break;
            case '\f':   result.append("\\f");      break;
            case '\\':   result.append("\\\\");     break;
            case '\'':   result.append("\\\'");     break;
            case '\"':   result.append("\\\"");     break;
            }
        }
        
        return '"' + result.toString() + '"';
    }
    private static String toHexCode(char ch) {
        String hex = "000" + Integer.toString(ch, 16).toUpperCase(Locale.ENGLISH);
        hex = hex.substring(hex.length() - 4);
        return hex;
    }
}

